#ifndef __UTIMER_H__
#define __UTIMER_H__

#include <windows.h>

class _Timer
{
protected :
    int m_FPS;
    float m_lastTime;
    float m_lastElapsedTime;
public :

    virtual int getFPS();
    virtual float getElapsedTime();
};

class UTimer
{

    _Timer *m_timer;
public :

    // initialize
    void init();

    // release
    void release();

    // get FPS
    int getFPS();

    // get elapsed time
    float getElapsedTime();
};

//
// high-res timer
//
class HPTimer : public _Timer
{

    LARGE_INTEGER m_ticksPerSecond;
public :
    // constructor
    HPTimer();

    // get FPS
    int getFPS();

    // get elapsed time
    float getElapsedTime();

};

//
// normal timer
//
class NormalTimer : public _Timer
{
public :
    // constructor
    NormalTimer();

    // get FPS
    int getFPS();

    // get elapsed time
    float getElapsedTime();
};

#endif